/* FILE:        AbstractAcquisitionInterface_Private.cpp
 * DATE:        1/7/2016
 * AUTHOR:      Jeremy Greene
 * COMPANY:     BitFlow, Inc.
 * COPYRIGHT:   Copyright (C) 2016, BitFlow, Inc.
 * DESCRIPTION: Implementation of ImageView::AbstractAcquisitionInterface::PrivateData.
 */

#include "AbstractAcquisitionInterface_Private.h"

ImageView::AbstractAcquisitionInterface::PrivateData::PrivateData (AbstractAcquisitionInterface &acqIf)
    : m_acqIf (acqIf)
    , m_hasSetup (false)
    , m_hasSetupMode (false)
    , m_hasCleanup (false)
    , m_hasTrigger (false)
    , m_hasStartSingleReverse (false)
    , m_hasStartReverse (false)
    , m_hasStart (false)
    , m_hasStartFixed (false)
    , m_hasStartSingle (false)
    , m_hasPause (false)
    , m_hasStop (false)
    , m_hasFrameRate (false)
    , m_hasFramesQueued (false)
    , m_hasFramesFilled (false)
    , m_hasFramesDropped (false)
    , m_hasFramesDelivered (false)

    , m_startFixedMin (1)
    , m_startFixedMax (65536)
    , m_startFixedInc (1)

    , m_signalHandler (acqIf)
{ }
