#ifndef INCLUDED__IMAGE__VIEW__ABSTRACT__ACQUISITION__INTERFACE_____PRIVATE__H
#define INCLUDED__IMAGE__VIEW__ABSTRACT__ACQUISITION__INTERFACE_____PRIVATE__H

/* FILE:        AbstractAcquisitionInterface_Private.h
 * DATE:        1/7/2016
 * AUTHOR:      Jeremy Greene
 * COMPANY:     BitFlow, Inc.
 * COPYRIGHT:   Copyright (C) 2016, BitFlow, Inc.
 * DESCRIPTION: PrivateData for ImageView::AbstractAcquisitionInterface.
 */

#include "AbstractAcquisitionInterface.h"
#include "AcquisitionSignalHandler.h"

#include <string>
#include <map>

#include <mutex>

struct ImageView::AbstractAcquisitionInterface::PrivateData
{
    typedef std::pair<std::string, std::string> StrPair;
    typedef std::vector<StrPair> StrPairVector;
    typedef std::map<std::string, std::string> StrStrMap;

    AbstractAcquisitionInterface &m_acqIf;

    bool m_hasSetup;
    bool m_hasSetupMode;
    bool m_hasCleanup;
    bool m_hasTrigger;
    bool m_hasStartSingleReverse;
    bool m_hasStartReverse;
    bool m_hasStart;
    bool m_hasStartFixed;
    bool m_hasStartSingle;
    bool m_hasPause;
    bool m_hasStop;
    bool m_hasFrameRate;
    bool m_hasFramesQueued;
    bool m_hasFramesFilled;
    bool m_hasFramesDropped;
    bool m_hasFramesDelivered;

    std::int32_t m_startFixedMin;
    std::int32_t m_startFixedMax;
    std::int32_t m_startFixedInc;

    StrPairVector m_setupModesVector;
    StrStrMap m_setupModesMap;

    AcquisitionSignalHandler m_signalHandler;

    // Constructor.
    PrivateData (AbstractAcquisitionInterface &acqIf);
};

#endif // INCLUDED__IMAGE__VIEW__ABSTRACT__ACQUISITION__INTERFACE_____PRIVATE__H
