#ifndef INCLUDED__BIT_FLOW__IMAGE__CONVERSION__HELPERS_____PRIVATE__H
#define INCLUDED__BIT_FLOW__IMAGE__CONVERSION__HELPERS_____PRIVATE__H

/* FILE:        ImageConversionHelpers_Private.h
 * DATE:        1/7/2016
 * AUTHOR:      Jeremy Greene
 * COMPANY:     BitFlow, Inc.
 * COPYRIGHT:   Copyright (C) 2016, BitFlow, Inc.
 * DESCRIPTION: PrivateData for ImageView::ImageConversion.
 */

#include "ImageConversionHelpers.h"
#include "ImageViewThread.h"

#include <vector>

#include <atomic>
#include <memory>

#include <mutex>
#include <condition_variable>
#include <future>

struct ImageView::ImageConversion::PrivateData
{
    const size_t m_logicalThreadCount;
    const size_t m_extraThreadCount;

    std::mutex m_logicalMultithreadedExeMutex;

    bool m_hasActiveFunc;
    Func m_activeFunc;
    std::mutex m_activeFuncMutex;
    std::condition_variable m_activeFuncCondition;

    std::vector<ImageView::thread> m_threads;
    size_t m_threadsAwake, m_funcsStarted;
    std::condition_variable m_threadAwokeCondition;

    std::atomic<bool> m_keepRunning;

    PrivateData (void);
    ~PrivateData (void);

    void checkThreads (void);
    void logicalThreadExe (std::promise<void> &launched, const size_t);
    void logicalMultithreadedExe (Func const& func);
};

#endif // INCLUDED__BIT_FLOW__IMAGE__CONVERSION__HELPERS_____PRIVATE__H
