TEMPLATE = lib
CONFIG += dll

QT += core gui widgets

QMAKE_CXXFLAGS += -std=c++11 -O2 -Wall -Wextra -Wno-unused-parameter -Wno-switch -Wno-reorder

versionGen.target = ImageViewVersionNo.h
versionGen.commands = touch $$versionGen.target
versionGen.depends = versionGen2
versionGen2.commands = cd $$PWD; sh VersionGen.sh

PRE_TARGETDEPS += ImageViewVersionNo.h
QMAKE_EXTRA_TARGETS += versionGen versionGen2

LOCAL_INCLUDEPATH = $$PWD/../BFQtLgplDialog
INCLUDEPATH += $$(BITFLOW_INSTALL_DIRS)/inc $${LOCAL_INCLUDEPATH}
DEPENDPATH += $${LOCAL_INCLUDEPATH}

LIBS += -L$$OUT_PWD/../BFQtLgplDialog -lBFQtLgplDialog

contains(QT_ARCH, i386) {
    unix:!macx: LIBS += -L$$(BITFLOW_INSTALL_DIRS)/32b/lib -lBFciLib -lpthread
} else {
    unix:!macx: LIBS += -L$$(BITFLOW_INSTALL_DIRS)/64b/lib -lBFciLib -lpthread
}


DEFINES += "IMAGEVIEW_LIB"

FORMS += \
    AboutImageView.ui \
    ImageViewWindow.ui

HEADERS += \
    AbstractAcquisitionInterface.h \
    AbstractAcquisitionInterface_Private.h \
    AbstractActionInterface.h \
    AbstractActionInterface_Private.h \
    AbstractFileInterface.h \
    AbstractFileInterface_Private.h \
    AcquisitionSignalHandler.h \
    BayerDemosaic.h \
    ImageConversionHelpers.h \
    ImageConversionHelpers_Private.h \
    ImageView.h \
    ImageViewAbstractLock.h \
    ImageViewAction.h \
    ImageViewAction_Private.h \
    ImageViewApplication.h \
    ImageViewApplication_Private.h \
    ImageViewBaseClass.h \
    ImageViewCApi.h \
    ImageViewCApi_Private.h \
    ImageViewCDef.h \
    ImageViewFileIO.h \
    ImageViewFileIO_Private.h \
    ImageViewImageAccessor.h \
    ImageViewImageAccessor_Private.h \
    ImageViewMessageBoxDialog.h \
    ImageViewMessageBoxDialog_Private.h \
    ImageViewMiniMap.h \
    ImageViewMiniMap_Private.h \
    ImageViewNative.h \
    ImageViewNative_Private.h \
    ImageViewPopover.h \
    ImageViewPopover_Private.h \
    ImageViewRawImage.h \
    ImageViewStringHelpers.h \
    ImageViewSurface.h \
    ImageViewSurface_Private.h \
    ImageViewSurfaceScrollArea.h \
    ImageViewSurfaceScrollArea_Private.h \
    ImageViewSurfaceStream.h \
    ImageViewSurfaceStream_Private.h \
    ImageViewWindow.h \
    ImageViewWindow_Private.h \
    ImageViewWindowQt.h \
    ImageViewWindowQt_Private.h \
    ImperativeAcquisitionInterface.h \
    ImperativeAcquisitionInterface_Private.h \
    resource.h \
    ImageViewThread.h \
    ImageViewVersionNo.h \
    ImageViewVersionAutoGen.h

SOURCES += \
    AbstractAcquisitionInterface.cpp \
    AbstractAcquisitionInterface_Private.cpp \
    AbstractActionInterface.cpp \
    AbstractFileInterface.cpp \
    AbstractFileInterface_Private.cpp \
    AcquisitionSignalHandler.cpp \
    ImageConversionHelpers.cpp \
    ImageViewAbstractLock.cpp \
    ImageViewAction.cpp \
    ImageViewApplication.cpp \
    ImageViewBaseClass.cpp \
    ImageViewCApi.cpp \
    ImageViewCApi_Private.cpp \
    ImageViewFileIO.cpp \
    ImageViewImageAccessor.cpp \
    ImageViewImageAccessor_Private.cpp \
    ImageViewMessageBoxDialog.cpp \
    ImageViewMiniMap.cpp \
    ImageViewNative.cpp \
    ImageViewPopover.cpp \
    ImageViewSurface.cpp \
    ImageViewSurface_Private.cpp \
    ImageViewSurfaceScrollArea.cpp \
    ImageViewSurfaceScrollArea_Private.cpp \
    ImageViewSurfaceStream.cpp \
    ImageViewSurfaceStream_Private.cpp \
    ImageViewWindow.cpp \
    ImageViewWindowQt.cpp \
    ImageViewWindowQt_Private.cpp \
    ImperativeAcquisitionInterface.cpp

RESOURCES += \
    Resources/ImageView.qrc

OTHER_FILES += \
    VersionGen.sh

DISTFILES += \
    VersionGen.sh
