#ifndef INCLUDED__BIT_FLOW__IMAGE__VIEW__ACTION_____PRIVATE__H
#define INCLUDED__BIT_FLOW__IMAGE__VIEW__ACTION_____PRIVATE__H

/* FILE:        ImageViewAction_Private.h
 * DATE:        8/11/2016
 * AUTHOR:      Jeremy Greene
 * COMPANY:     BitFlow, Inc.
 * COPYRIGHT:   Copyright (C) 2016, BitFlow, Inc.
 * DESCRIPTION: Private data for ImageView::Action.
 */

#include <QAction>

#include "ImageViewAction.h"
#include "AbstractActionInterface.h"

class ImageView::Action::PrivateData : public QObject
{
    Q_OBJECT;

private:
    // Illegal.
    PrivateData (void);
    PrivateData (PrivateData const&);
    PrivateData& operator= (PrivateData const&);

public:
    // Members.
    Action *m_parent;
    Window *m_window;
    QAction *m_actionQt;
    ScopedActionInterface m_actionInterface;

    PrivateData (Action *const a_parent, Window *const a_window, QAction *const a_actionQt, ScopedActionInterface &&a_actionInterface);

public slots:
    void actionQtDestroyed (void);
    void actionQtTriggered (const bool checked);
};

#endif // INCLUDED__BIT_FLOW__IMAGE__VIEW__ACTION_____PRIVATE__H
