#ifndef INCLUDED__BIT_FLOW__IMAGE_VIEW__FILE__I_O_____PRIVATE__H
#define INCLUDED__BIT_FLOW__IMAGE_VIEW__FILE__I_O_____PRIVATE__H

/* FILE:        ImageViewFileIO_Private.h
 * DATE:        4/4/2016
 * AUTHOR:      Jeremy Greene
 * COMPANY:     BitFlow, Inc.
 * COPYRIGHT:   Copyright (C) 2016, BitFlow, Inc.
 * DESCRIPTION: Methods for image file input output. Supported file types: JPG, PNG, BMP.
 */

#include "ImageViewFileIO.h"

#include "ImageViewImageAccessor.h"

#include <QImage>
#include <QFileInfo>

#include <vector>

struct ImageView::FileIO::PrivateData
{
    QImage m_image;
    std::vector<std::uint8_t> m_imageData;

    ImageAccessor m_imageAccessor;

    // Determine if the file path extension is supported.
    inline static bool isValidExtension (QString const& filePath)
    {
        const auto suffix = QFileInfo(filePath).suffix();

        return suffix.compare("jpg", Qt::CaseInsensitive)
            || suffix.compare("jpeg", Qt::CaseInsensitive)
            || suffix.compare("png", Qt::CaseInsensitive)
            || suffix.compare("bmp", Qt::CaseInsensitive);
    }
};

#endif // INCLUDED__BIT_FLOW__IMAGE_VIEW__FILE__I_O_____PRIVATE__H
