#ifndef INCLUDED__BIT_FLOW__IMAGE_VIEW__IMAGE__ACCESSOR_____PRIVATE__H
#define INCLUDED__BIT_FLOW__IMAGE_VIEW__IMAGE__ACCESSOR_____PRIVATE__H

/* FILE:        ImageViewImageAccessor_Private.h
 * DATE:        4/4/2016
 * AUTHOR:      Jeremy Greene
 * COMPANY:     BitFlow, Inc.
 * COPYRIGHT:   Copyright (C) 2016, BitFlow, Inc.
 * DESCRIPTION: Methods for image data conversion and access.
 */

#include "ImageViewImageAccessor.h"

#include "ImageConversionHelpers.h"

struct ImageView::ImageAccessor::PrivateData
{
    ImageConversion m_imageConverter;

    // Direct buffer-to-QImage conversion.
    static QImage makeQImageGray (std::vector<uchar> &qImageData, const int width, const int height);
    static QImage makeQImageColor (std::vector<uchar> &qImageData, const int width, const int height, const bool alpha);

    bool validateQImageGray (QImage &image, const int width, const int height);
    bool validateQImageColor (QImage &image, const int width, const int height);

    bool imageCopy8 (QImage &image, std::vector<uchar> &qImageData, RawImage const& rawImage);
    bool imageCopy16 (QImage &image, std::vector<uchar> &qImageData, RawImage const& rawImage);
    bool imageCopy24 (QImage &image, std::vector<uchar> &qImageData, RawImage const& rawImage);
    bool imageCopy30 (QImage &image, std::vector<uchar> &qImageData, RawImage const& rawImage);
    bool imageCopy32 (QImage &image, std::vector<uchar> &qImageData, RawImage const& rawImage);
    bool imageCopy48 (QImage &image, std::vector<uchar> &qImageData, RawImage const& rawImage);

    bool imageDecodeBayer8 (QImage &image, std::vector<uchar> &qImageData, RawImage const& rawImage);
    bool imageDecodeBayer16 (QImage &image, std::vector<uchar> &qImageData, RawImage const& rawImage);
};

#endif // INCLUDED__BIT_FLOW__IMAGE_VIEW__IMAGE__ACCESSOR_____PRIVATE__H
