#ifndef INCLUDED__BIT_FLOW__IMAGE__VIEW__MINI__MAP_____PRIVATE__H
#define INCLUDED__BIT_FLOW__IMAGE__VIEW__MINI__MAP_____PRIVATE__H

/* FILE:        ImageViewMiniMap_Private.h
 * DATE:        1/7/2016
 * AUTHOR:      Jeremy Greene
 * COMPANY:     BitFlow, Inc.
 * COPYRIGHT:   Copyright (C) 2016, BitFlow, Inc.
 * DESCRIPTION: Private data for ImageView::MiniMap.
 */

#include "ImageViewMiniMap.h"

struct ImageView::MiniMap::PrivateData : public QObject
{
    Q_OBJECT;

public:
    // Members.
    MiniMap &m_miniMap;

    QPixmap m_pixmap;

    QSizeF m_boundarySize;
    QRectF m_viewRect;
    double m_scaling;
    double m_localScaling;

    bool m_mouseOutlineHover;
    bool m_mousePress;
    bool m_mouseDrag;
    QPointF m_mousePressPos;
    QPointF m_offsetInit;

    // Helpers.
    void localUpdate (void);
    void cursorUpdate (QPoint const& pos = QCursor::pos());

    QRectF scaledViewRect (void) const;

    // Constructor.
    PrivateData (MiniMap &miniMap);

public slots:
    void emitOffsetChanged (void);
};

#endif // INCLUDED__BIT_FLOW__IMAGE__VIEW__MINI__MAP_____PRIVATE__H
