#ifndef INCLUDED__BIT_FLOW__IMAGE__VIEW__NATIVE__H
#define INCLUDED__BIT_FLOW__IMAGE__VIEW__NATIVE__H

/* FILE:        ImageViewNative.h
 * DATE:        1/15/2016
 * AUTHOR:      Jeremy Greene
 * COMPANY:     BitFlow, Inc.
 * COPYRIGHT:   Copyright (C) 2016, BitFlow, Inc.
 * DESCRIPTION: Tools and definitions for integration with the current operating system.
 */

#if defined(_WIN32)

// Windows platform details.
#   if !defined(WIN32_LEAN_AND_MEAN)
#       define WIN32_LEAN_AND_MEAN
#   endif
#   if !defined(NOMINMAX)
#       define NOMINMAX
#   endif
#   include <Windows.h>

#   define IMAGE_VIEW_NATIVE_WINDOW HWND
#   define IMAGE_VIEW_NATIVE_ICON HICON

// C++ platform details.
#   if defined(__cplusplus)
#       if !defined(QWIDGET_H)
class QWidget;
#       endif
#       if !defined(QACTION_H)
class QAction;
#       endif
#   endif

#elif defined(__GNUC__)

#   define IMAGE_VIEW_NATIVE_WINDOW unsigned long*

// C++ platform details.
#   if defined(__cplusplus)
#       if !defined(QWIDGET_H)
class QWidget;
#       endif
#       if !defined(QACTION_H)
class QAction;
#       endif
#   endif

#else

#   error "ImageView does not support this platform yet."

#endif

#endif // INCLUDED__BIT_FLOW__IMAGE__VIEW__NATIVE__H
