#ifndef INCLUDED__BIT_FLOW__IMAGE__VIEW__POPOVER_____PRIVATE__H
#define INCLUDED__BIT_FLOW__IMAGE__VIEW__POPOVER_____PRIVATE__H

/* FILE:        ImageViewPopover_Private.h
 * DATE:        1/7/2016
 * AUTHOR:      Jeremy Greene
 * COMPANY:     BitFlow, Inc.
 * COPYRIGHT:   Copyright (C) 2016, BitFlow, Inc.
 * DESCRIPTION: Private data for ImageView::Popover.
 */

#include "ImageViewPopover.h"

#include <QLabel>
#include <QPushButton>
#include <QHBoxLayout>

struct ImageView::PopoverWindow::PrivateData : public QObject
{
    Q_OBJECT;

public:
    PopoverWindow &m_window;

    // Members.
    QWidget *m_affinityWidget;
    AffinityEnum m_affinity;

    QWidget *m_centralWidget;

    QBoxLayout *m_popoverLayout;
    QLabel *m_popoverLabel;
    QPushButton *m_rejectButton;
    QPushButton *m_acceptButton;

    bool m_rejectOnFocusOut;

    // Helpers.
    void reallign (void);
    void reflow (const Qt::Orientation orientation);
    void updateMargin (void);

    // Event filter.
    bool eventFilter (QObject *const watched, QEvent *const evt) override;

    // Constructor.
    PrivateData (PopoverWindow &window);
};

#endif // INCLUDED__BIT_FLOW__IMAGE__VIEW__POPOVER_____PRIVATE__H
