#ifndef INCLUDED_BIT_FLOW__IMAGE__VIEW__RAW__IMAGE__H
#define INCLUDED_BIT_FLOW__IMAGE__VIEW__RAW__IMAGE__H

/* FILE:        ImageViewRawImage.h
 * DATE:        1/7/2016
 * AUTHOR:      Jeremy Greene
 * COMPANY:     BitFlow, Inc.
 * COPYRIGHT:   Copyright (C) 2016, BitFlow, Inc.
 * DESCRIPTION: Raw image container for the ImageView library.
 */

#include "ImageView.h"

#include <cstdint>
#include <utility>

namespace ImageView
{
    struct RawImage
    {
        const std::uint8_t *m_buffer;
        size_t m_width;
        size_t m_height;
        Format m_format;
        void *m_userData;
    };

    struct PixPos
    {
        size_t x, y;

        PixPos (const size_t ax, const size_t ay)
            : x (ax)
            , y (ay)
        { }

        PixPos (std::pair<size_t, size_t> const& pos)
            : x (pos.first)
            , y (pos.second)
        { }
    };

    struct PixVal
    {
        bool isGrayscale;
        std::uint32_t gray;

        bool isColor;
        std::uint32_t r, g, b;
    };
}

#endif // INCLUDED_BIT_FLOW__IMAGE__VIEW__RAW__IMAGE__H

