#ifndef INCLUDED__BIT_FLOW__IMAGE__VIEW__IMAGE__VIEW__THREAD__H
#define INCLUDED__BIT_FLOW__IMAGE__VIEW__IMAGE__VIEW__THREAD__H

/* FILE:        ImageViewThread.h
 * DATE:        1/7/2016
 * AUTHOR:      Jeremy Greene
 * COMPANY:     BitFlow, Inc.
 * COPYRIGHT:   Copyright (C) 2016, BitFlow, Inc.
 * DESCRIPTION: ImageView thread support.
 */

#if defined(_WIN32)

#   include <boost/thread.hpp>
#   include <boost/functional.hpp>

namespace ImageView
{
    typedef boost::thread thread;
    namespace this_thread = boost::this_thread;

    template<typename T>
    inline boost::reference_wrapper<T> ref (T &r)
    {
        return boost::ref(r);
    }
}

#elif defined(__GNUC__)

#   include <thread>
#   include <functional>

namespace ImageView
{
    typedef std::thread thread;
    namespace this_thread = std::this_thread;

    template<typename T>
    inline std::reference_wrapper<T> ref (T &r)
    {
        return std::ref(r);
    }
}

#else
#   error No thread support implementation on this platform.
#endif

#endif // INCLUDED__BIT_FLOW__IMAGE__VIEW__IMAGE__VIEW__THREAD__H
