#ifndef INCLUDED__BIT_FLOW__IMAGE_VIEW__IMAGE__VIEW__VERSION__NO__H
#define INCLUDED__BIT_FLOW__IMAGE_VIEW__IMAGE__VIEW__VERSION__NO__H

/* FILE:        ImageViewVersionBase.h
 * DATE:        10/17/2016
 * AUTHOR:      Jeremy Greene
 * COMPANY:     BitFlow, Inc.
 * COPYRIGHT:   Copyright (C) 2016, BitFlow, Inc.
 * DESCRIPTION: Base features of ImageViewVersionNo.h
 */

#define IMAGE_VIEW_VERSION_MAJOR 1
#define IMAGE_VIEW_VERSION_MINOR 0
#define IMAGE_VIEW_VERSION_SUFFIX ""

#define IMAGE_VIEW_VERSION_STRINGIZE(V) #V
#define IMAGE_VIEW_VERSION_TOSTRING(V) IMAGE_VIEW_VERSION_STRINGIZE(V)

#define IMAGE_VIEW_VERSION_MAJOR_STR IMAGE_VIEW_VERSION_TOSTRING(IMAGE_VIEW_VERSION_MAJOR)
#define IMAGE_VIEW_VERSION_MINOR_STR IMAGE_VIEW_VERSION_TOSTRING(IMAGE_VIEW_VERSION_MINOR)

#include "ImageViewVersionAutoGen.h"

#define IMAGE_VIEW_BUILDVERSION_MAJOR_STR IMAGE_VIEW_VERSION_TOSTRING(IMAGE_VIEW_BUILDVERSION_MAJOR)
#define IMAGE_VIEW_BUILDVERSION_MINOR_STR IMAGE_VIEW_VERSION_TOSTRING(IMAGE_VIEW_BUILDVERSION_MINOR)

#define IMAGE_VIEW_FILEVER          IMAGE_VIEW_VERSION_MAJOR,IMAGE_VIEW_VERSION_MINOR,IMAGE_VIEW_BUILDVERSION_MAJOR,IMAGE_VIEW_BUILDVERSION_MINOR
#define IMAGE_VIEW_STRFILEVER       IMAGE_VIEW_VERSION_MAJOR_STR "." IMAGE_VIEW_VERSION_MINOR_STR "." IMAGE_VIEW_BUILDVERSION_MAJOR_STR "." IMAGE_VIEW_BUILDVERSION_MINOR_STR IMAGE_VIEW_VERSION_SUFFIX
#if defined(_WIN32)
#   include <BFVersion.h>
#   define IMAGE_VIEW_PLATFORM_WIN32 (1)
#   define IMAGE_VIEW_PLATFORM_LINUX (0)
#   define IMAGE_VIEW_PRODUCTVER BF_PRODUCT_VERSION_NUMBERS
#   define IMAGE_VIEW_STRPRODUCTVER BF_PRODUCT_VERSION_STRING
#   define IMAGE_VIEW_SDK_VERSION_MAJOR BF_SDK_VERSION_MAJOR
#   define IMAGE_VIEW_SDK_VERSION_MINOR BF_SDK_VERSION_MINOR
#   define IMAGE_VIEW_SDK_VERSION_BUG BF_SDK_VERSION_BUG
#elif defined(__GNUC__)
#   define IMAGE_VIEW_PLATFORM_WIN32 (0)
#   define IMAGE_VIEW_PLATFORM_LINUX (1)
#else
#    error Driver static version retrieval unsupported on this platform.
#endif

#define IMAGE_VIEW_APPVERSION       "Version " IMAGE_VIEW_VERSION_MAJOR_STR "." IMAGE_VIEW_VERSION_MINOR_STR IMAGE_VIEW_VERSION_SUFFIX
#ifdef _DEBUG
#define IMAGE_VIEW_BUILDVERSION     "Build " IMAGE_VIEW_BUILDVERSION_MAJOR_STR "." IMAGE_VIEW_BUILDVERSION_MINOR_STR " [debug]"
#else
#define IMAGE_VIEW_BUILDVERSION     "Build " IMAGE_VIEW_BUILDVERSION_MAJOR_STR "." IMAGE_VIEW_BUILDVERSION_MINOR_STR
#endif

#if defined(LINX_BUILD_TARGET)
#   define IMAGE_VIEW_CORPORATE_NAME_FULL "LinX Corporation"
#   define IMAGE_VIEW_CORPORATE_NAME_ABRV "LinX"
#   define IMAGE_VIEW_CORPORATE_LINK "http://www.linx.jp/"
#   define IMAGE_VIEW_CORPORATE_LINK_DISP "www.LinX.com"
#else
#   define IMAGE_VIEW_CORPORATE_NAME_FULL "BitFlow, Inc."
#   define IMAGE_VIEW_CORPORATE_NAME_ABRV "BitFlow"
#   define IMAGE_VIEW_CORPORATE_LINK "http://www.bitflow.com/"
#   define IMAGE_VIEW_CORPORATE_LINK_DISP "www.BitFlow.com"
#endif

#define IMAGE_VIEW_COPYRIGHT        "Copyright " IMAGE_VIEW_COPYRIGHT_SYMBOL " " IMAGE_VIEW_COPYRIGHT_TERM ", " IMAGE_VIEW_CORPORATE_NAME_FULL
#define IMAGE_VIEW_COPYRIGHT_HTML   "<html>Copyright &copy; " IMAGE_VIEW_COPYRIGHT_TERM ", <a href=\"" IMAGE_VIEW_CORPORATE_LINK "\">" IMAGE_VIEW_CORPORATE_NAME_FULL "</a></html>"

#endif // INCLUDED__BIT_FLOW__IMAGE_VIEW__IMAGE__VIEW__VERSION__NO__H
