#ifndef INCLUDED__BIT_FLOW__IMAGE__VIEW__WINDOW_____PRIVATE__H
#define INCLUDED__BIT_FLOW__IMAGE__VIEW__WINDOW_____PRIVATE__H

/* FILE:        ImageViewWindow_Private.h
 * DATE:        1/7/2016
 * AUTHOR:      Jeremy Greene
 * COMPANY:     BitFlow, Inc.
 * COPYRIGHT:   Copyright (C) 2016, BitFlow, Inc.
 * DESCRIPTION: PrivateData for ImageView::Window.
 */

#include "ImageViewWindow.h"

#include "ImageViewWindowQt.h"

#include "ui_AboutImageView.h"

#include <vector>
#include <atomic>
#include <mutex>
#include <map>

#include <QPointer>

struct ImageView::Window::PrivateData : public QObject
{
    Q_OBJECT;

public:
    // Members.
    Window &m_parent;
    WindowQt *m_windowQt;

    QDialog *m_appAboutDialog;
    Ui::aboutImageViewDialog m_appAboutDialogUi;

    IMAGE_VIEW_NATIVE_WINDOW m_nativeWindow;
    IMAGE_VIEW_NATIVE_WINDOW m_parentWindow;

    PrivateData (Window &parent);

public slots:
    void windowQtDestroyed (void);
};

#endif // INCLUDED__BIT_FLOW__IMAGE__VIEW__WINDOW_____PRIVATE__H
