#!/bin/bash

# Copyright (C) 2016, BitFlow, Inc.

# Retrieve the epoch seconds
epochTime="$(date +%s)"

# Setup the implementation date.
implementationDate="2015-12-03"
implementationEpoch=$(date -d$implementationDate +%s)

implementationYear=$(date -d$implementationDate +%Y)
yearNow=$(date +%Y)

# Determine how long it's been since we were implemented.
dateDiff=$((epochTime-implementationEpoch))

# Calculate the build version.
buildVersionMinor=$((dateDiff % 65536))
buildVersionMajor=$(((dateDiff - buildVersionMinor) / 65536))

# Write ImageViewVersionAutoGen.h

echo "#ifndef INCLUDED__BIT_FLOW__IMAGE__VIEW__VERSION__AUTO__GEN__H" >ImageViewVersionAutoGen.h
echo "#define INCLUDED__BIT_FLOW__IMAGE__VIEW__VERSION__AUTO__GEN__H" >>ImageViewVersionAutoGen.h
echo "" >>ImageViewVersionAutoGen.h
echo "// Auto generated project information. See VersionGen.sh for details." >>ImageViewVersionAutoGen.h
echo "// Generated at: " $(date) >>ImageViewVersionAutoGen.h

echo "" >>ImageViewVersionAutoGen.h
echo "#define IMAGE_VIEW_BUILDVERSION_MAJOR "$buildVersionMajor >>ImageViewVersionAutoGen.h
echo "#define IMAGE_VIEW_BUILDVERSION_MINOR "$buildVersionMinor >>ImageViewVersionAutoGen.h

echo "" >>ImageViewVersionAutoGen.h
if [ $implementationYear -lt $yearNow ]
then
    echo "#define IMAGE_VIEW_COPYRIGHT_TERM \""$implementationYear"-"$yearNow"\"" >>ImageViewVersionAutoGen.h
else
    echo "#define IMAGE_VIEW_COPYRIGHT_TERM \""$yearNow"\"" >>ImageViewVersionAutoGen.h
fi

echo "" >>ImageViewVersionAutoGen.h
echo "#define IMAGE_VIEW_COPYRIGHT_SYMBOL \"©\"" >>ImageViewVersionAutoGen.h

echo "" >>ImageViewVersionAutoGen.h
echo "#endif // INCLUDED__BIT_FLOW__IMAGE__VIEW__VERSION__AUTO__GEN__H" >>ImageViewVersionAutoGen.h
echo "" >>ImageViewVersionAutoGen.h
